-- Function: scmdb_update()

-- DROP FUNCTION scmdb_update();

CREATE OR REPLACE FUNCTION scmdb_update()
  RETURNS integer AS
$BODY$
declare
oname varchar;
oid integer;
vertex_id integer;
vertex_name varchar;
vertex_agent_id integer;
agent_name varchar;
fhost_name varchar;
ci_name varchar;
rel_id integer;
t timestamp = now() - interval '30 days';

begin
for oid, oname in select id, translate (name, '/', '_') from apm_owner where update_date > t loop
	--raise notice 'oid, oname: % %',oid, oname;	
	for vertex_id in execute 'select apm_edge.head_vertex_id from apm_edge where apm_edge.owner_id = '|| oid ||' and update_date > ' || quote_literal(t) || ' ' loop
		execute 'select split_part(name,'' '',2), agent_id from apm_vertex where name like ''%on port%'' and update_date > ' || quote_literal(t) || ' and id = '|| vertex_id ||'' into vertex_name, vertex_agent_id;
		if vertex_name is not null then
			--raise notice 'vertex_name: %',vertex_name;
			execute 'select name, fully_qualified_host_name from apm_agent where id=' || vertex_agent_id || '' into agent_name, fhost_name;
			--raise notice 'vertex_agent_id, agent_name, fhost_name: %, %, %',vertex_agent_id, agent_name, fhost_name;		
			execute 'select id, host from scmdb where host like ' || quote_literal(fhost_name) || ' and service like ' || quote_literal(oname) || ' ' into rel_id, ci_name;
			if ci_name is null then
				execute 'insert into scmdb (service,host,status) values (' || quote_literal(oname) || ',' || quote_literal(fhost_name) || ',''A'')';
			else
				execute 'update scmdb set status = ''A'' where id = ' || rel_id || '';
			end if;
			ci_name = null;
			execute 'select id, host from scmdb where host like ' || quote_literal(vertex_name) || ' and service like ' || quote_literal(oname) || ' ' into rel_id, ci_name;
			if ci_name is null then
				execute 'insert into scmdb (service,host,status) values (' || quote_literal(oname) || ',' || quote_literal(vertex_name) || ',''A'')';			
			end if;
			vertex_name = null;
			ci_name = null;
		end if;		
	end loop;
end loop;
return 0;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION scmdb_update() OWNER TO "admin";
